// main file of Windows Commander Application
// Copyright 2006, 2007 Easy Hacker
// Versions history:
// Initial version 0.1.0 -- Aug 2005
// Current verion  1.0.2 -- Feb 2007

// max history items
var max_history = 20;

// arrays of input history
var RunHistoryArr ;
var FolderHistoryArr ;

// array
var RunBookmarks;
var FolderBookmarks;


// returns windows path with double backslashes
function WinPath(path)
{
   return DoubleSlashes(path);
}

// returns quoted string
function Quoted( str ) 
{
    return "\"" + str + "\"";
}

// executes windows search
function WinSearch(start_from, search_pattern, search_text) 
{
    var command;
    var fr, pattern, text, log_file, batch, batch_file;
    log("WinSearch");
    
    command = "";
    log("Search pattern " + search_pattern );
    pattern = Quoted( search_pattern );
    text = search_text;

    log("Search text " + text );
    log(pattern);

    log_file = "%TEMP%\\wcommander.log";
    batch_file = system.temporaryFolder +"/wcommander.bat";
    log_file = convertPathToPlatform( system.temporaryFolder +"/wcommander.log");

    batch = new Array(4);

    log(batch);

    if( start_from != "" ) {

	fr = Quoted(start_from);
	command = "pushd " + fr;
	 
    } else {
    }

    log(command);
    batch[0] = command;

    if( search_text == "" ) {
	command = "dir " + pattern + " /s/b";
    } else {
	command = "findstr /i /S " + text + " " + pattern;
    }
 
    command = command + " >" + log_file;
    log(command);

    var dos_path;
    dos_path = WinPath( convertPathToPlatform(batch_file) );

    batch[1] = command;
    batch[2] = "start notepad " + log_file;
    batch[3] = "exit";

    filesystem.writeFile(batch_file, batch);
    var res;
    res=filesystem.open(batch_file);
    log("result " + res);
 }


// run command specified in Run field
function RunCommand()
{

    var batch_file;
    log("RunCommand");

    log(Command.data);
    AddToHistory(Command.data, "Run");
    batch_file = system.temporaryFolder +"/runwcommander.bat";

    var dos_path;
    dos_path = WinPath( convertPathToPlatform(batch_file) );

    filesystem.writeFile(batch_file, "start " + Command.data);

    var res;
    res = filesystem.open(batch_file);

    log("result " + res);

}

// run command through batch file
function RunCommandBG(cmd_string)
{

    var batch_file;
    log("RunCommandBG");
    batch_file = system.temporaryFolder +"/runwcommander.bat";
    filesystem.writeFile(batch_file, "start " + cmd_string);

    var res;
    res = filesystem.open(batch_file);

    log("result " + res);
}

function RunHistoryMenu()
{
	var HistArr;
	var cmd_prefix, cmd_suffix;
	HistArr = RunHistoryArr;
	cmd_prefix = "Command.data = '";
	cmd_suffix = "';Command.focus();";

	return HistoryPopup(RunHistoryArr, cmd_prefix, cmd_suffix);
}

function RunBookmarksMenu()
{
	var cmd_prefix, cmd_suffix;
	cmd_prefix = "Command.data = '";
	cmd_suffix = "';Command.focus();";

	return BookmarksPopup(RunBookmarks, cmd_prefix, cmd_suffix,"Run");
}

function FolderBookmarksMenu()
{
	var cmd_prefix, cmd_suffix;
	cmd_prefix = "Folder.data = '";
	cmd_suffix = "';Folder.focus();";

	return BookmarksPopup(FolderBookmarks, cmd_prefix, cmd_suffix,"Folder");
}

//returns popup menu with list of previously explored folders
function FolderHistoryMenu()
{
	var HistArr;
	var cmd_prefix, cmd_suffix;
	cmd_prefix = "Folder.data=\"";
	cmd_suffix = "\";Folder.focus();";

	return HistoryPopup(FolderHistoryArr, cmd_prefix, cmd_suffix);
}

//returns generic history popup menu
function HistoryPopup(HistArr, cmd_prefix, cmd_suffix) 
{
	log("HistoryPopup");

	var items = new Array();
	var cmd;

	log(HistArr.length);
	for (var i =0; i < HistArr.length; i++ ) {

	  if( HistArr[i] != "" ) {
	        log(i);
		items[i] = new MenuItem;
		items[i].title = HistArr[i];
		items[i].enabled = true;
		cmd = cmd_prefix + DoubleSlashes(HistArr[i]) + cmd_suffix;
		//cmd = cmd +";Folder.focus();"
		items[i].onSelect = cmd;
		log(cmd);
	  }
	}
	return items;
}
//returns generic bookmarks popup menu
function BookmarksPopup(HistArr, cmd_prefix, cmd_suffix, bm_type) 
{
	log("BookmarksPopup");

	var items = new Array();
	var cmd;

	log(HistArr.length);
	items[0] = new MenuItem;
	items[0].title = "Add Bookmark";
	items[0].onSelect = "AddBookmark(" + Quoted(bm_type) + ")";
	items[1] = new MenuItem;
	items[1].title = "Edit Bookmarks";
	items[1].onSelect = "EditBookmarks(" + Quoted(bm_type) + ")";

	var j;
	for (var i =0, j=2; i < HistArr.length; i++,j++ ) {

	  if( HistArr[i] != "" ) {
		items[j] = new MenuItem;
		items[j].title = "Bookmark: " + HistArr[i];
		items[j].enabled = true;
		cmd = cmd_prefix + DoubleSlashes(HistArr[i]) + cmd_suffix;
		items[j].onSelect = cmd;
		log(cmd);
	  }
	}
	return items;
}
// add to history arrays
function AddToHistory(str, history_type)
{
	var i,j, max;
	var mystr = new String(str);
	var hist_arr;
	if( history_type == "Run") 
	{
	  hist_arr = RunHistoryArr;
	} else {
	  if( history_type == "Folder") {
	      hist_arr = FolderHistoryArr;
	  }
	}

	i=hist_arr.length;

	// do not insert duplicated history elements
	for ( j = 0 ; j < i ; j++ )
	{
		if( hist_arr[j] == str ) return;
	}

	hist_arr.unshift(mystr);

	if( i == max_history ) {
	    hist_arr.pop();
	    log(hist_arr.length);
	}

	SaveHistory(hist_arr, history_type);
}

// add to historybookmark arrays
function AddBookmark(history_type)
{
	var i,j, max;
	var mystr ;
	var hist_arr;
	if( history_type == "Run") 
	{
	  hist_arr = RunBookmarks;
	  mystr = Command.data;
	} else {
	  if( history_type == "Folder") {
	      hist_arr = FolderBookmarks;
	      mystr = Folder.data      
	  }
	}

	i=hist_arr.length;
	if(mystr == "") return;

	// do not insert duplicated history elements
	for ( j = 0 ; j < i ; j++ )
	{
		if( hist_arr[j] == mystr ) return;
	}

	hist_arr.unshift(mystr);

	if( i == max_history ) {
	    hist_arr.pop();
	    log(hist_arr.length);
	}

	SaveBookmarks(hist_arr, history_type);
}



// save
function SaveHistory(HistArr, history_type)
{

 var fname = system.temporaryFolder + "/wincommander." + history_type +".history";
  filesystem.writeFile(fname, HistArr);
}

// read history
function ReadHistory(history_type)
{
 var HistArr;
 var fname = system.temporaryFolder + "/wincommander." + history_type +".history";

 if( filesystem.itemExists(fname) ) {
     HistArr = filesystem.readFile(fname, true);
 } else {
     HistArr = new Array();
 }

 return HistArr;
}

// save bookmarks
function SaveBookmarks(HistArr, history_type)
{

 var fname = WCBookmarksFile(history_type);
  filesystem.writeFile(fname, HistArr);
}

// read bookmarks
function ReadBookmarks(history_type)
{
 var HistArr;
 var fname = WCBookmarksFile(history_type);

 if( filesystem.itemExists(fname) ) {
     HistArr = filesystem.readFile(fname, true);
 } else {
     HistArr = new Array();
 }

 return HistArr;
}


// read all files
function ReadFiles()
{
	RunHistoryArr = ReadHistory("Run");
	FolderHistoryArr = ReadHistory("Folder");
	ReadAllBookmarks();
}

function ReadAllBookmarks() 
{
	RunBookmarks = ReadBookmarks("Run");
	FolderBookmarks = ReadBookmarks("Folder");

}

//explore folder specified in Dir field
function Explore() 
{

    if( Folder.data == "" ) return;
    var tmp = Folder.data;
    log(Folder.data);
    if( tmp.substr(0,4) == "http") {
	openURL(Folder.data);
    } else {
      pth = convertPathToPlatform(Folder.data);
      filesystem.open(pth);
    }
    AddToHistory(Folder.data, "Folder");
}

// convert all single back slashes to double
function DoubleSlashes(str)
{
   var pattern = /\\/g;
   return str.replace(pattern, "\\\\");

}

function PerformSearch() 
{
    if( Search.data == "" ) return;
    WinSearch(Folder.data, Search.data, SearchText.data);
}


function ExploreBookmark()
{
}

function EditBookmarks(history_type)
{
    RunCommandBG("notepad " + WinPath(convertPathToPlatform(WCBookmarksFile(history_type))) );
    ReadAllBookmarks();
}

function CreateMenuItemsArray(bmarks, prefix , cmd)
{
    var items = new Array();
    var i;

    for(i=0; i < bmarks.length; i++) {
	var it = bmarks[i];
	log(it);
	items[i] = new MenuItem();
	items[i].title = prefix + it;
	//items[i].onSelect = Quoted(cmd + "(" + Quoted(it) + ")");
	items[i].onSelect = "Explore();";
	log(items[i].onSelect);
    }

    return items;

}

function ExploreBmark( adr )
{
    log("explorer " + WinPath(adr));
}

function WCBookmarksFile(history_type)
{
    return system.userDocumentsFolder + "/wincommander." + history_type +".bookmarks";
}
